(in-package "MXML")

(defun groupnotation (self)  
   (list "<notations>"
         (if (in-group? self)
             (let* ((lvl (get-grp-level self))
                    (ratio (getratiogroup (om::parent self)))
                    (act-note (second lvl))
                    (norm-note (third lvl))
                    (indx (car lvl))
                    (numdeno (getallgroups self))
                    (numdenom (remove nil 
                                      (loop for i in numdeno
                                            collect (if (not (= 1 (/ (car i) (second i)))) i) 
                                            )))
                    (simpli (/ act-note norm-note)))
               (print (list "ratio:" ratio))

               (if (not (= (/ (car ratio) (second ratio)) 1))
                   (cond 
                    ((and (om::last-of-group? self) (om::first-of-group? self))
                     (when (accent? self) (list (accent-notation self))))
                    ((and (om::first-of-group? self)  (not (om::last-of-group? self)))
                     (progn 
                       (print (list self ratio))
                       (remove nil 
                               (append 
                                (let ((obj self)
                                      (indx (+ (length numdenom) 1)))
                               
                                  (remove nil (loop for i in (reverse numdenom)           
                                                    append (progn 
                                                             (setf obj (om::parent obj))
                                                             (setf indx (- indx 1))
                                                             (when (first-of-this-group self obj)
                                                               (firstofgroup (car i) (second i) (third i) indx))))))
                                (list (tied-notation self)
                                      (when (accent? self) (accent-notation self)))))
                       )
                     )
                    ((and (om::last-of-group? self) (not (om::first-of-group? self)))
                     (remove nil 
                             (append 
                              (let ((obj self)
                                    (indx (+ (length numdenom) 1)))
                                (remove nil (loop for i in numdenom           
                                                  append (progn 
                                                           (setf obj (om::parent obj))
                                                           (setf indx (- indx 1))
                                                           (when (last-of-this-group self obj)
                                                             (lastofgroup indx))))))
                              (list (tied-notation self)
                                    (when (accent? self) (accent-notation self))))))
                   
                    (t (when (accent? self) (list (accent-notation self)))))
                 
                 (if (and ratio (= (/ (car ratio) (second ratio)) 1))
                     (cond 
                      ((and (om::last-of-group? self) (om::first-of-group? self))
                       (when (accent? self) (list (accent-notation self))))
                      ((and (om::first-of-group? self)  (not (om::last-of-group? self)))
                       (progn 
                         (print (list self ratio))
                         (remove nil 
                                 (append 
                                  (let ((obj self)
                                        (indx (+ (length numdenom) 1)))
                               
                                    (remove nil (loop for i in (reverse numdenom)           
                                                      append (progn 
                                                               (setf obj (om::parent obj))
                                                               (setf indx (- indx 1))
                                                               (when (first-of-this-group self obj)
                                                                 (firstofgroup (car i) (second i) (third i) indx))))))
                                  (list (tied-notation self)
                                        (when (accent? self) (accent-notation self)))))
                         )
                       )
                      (t (when (accent? self) (list (accent-notation self)))))
                 
                   (when (or (tied? self) (accent? self))
                     (remove nil 
                             (list 
                              (when (tied? self) (tied-notation self))
                              (when (accent? self) (accent-notation self)))))


                 
                   )
                 )
               )
           
           (when (or (tied? self) (accent? self))
             (remove nil 
                     (list 
                      (when (tied? self) (tied-notation self))
                      (when (accent? self) (accent-notation self)))))
           )
        
         ;;; VEL
         (velocity-as-xml self)
         "</notations>"
         ))